searchData={"items":[{"type":"module","title":"BCApis.Countries","doc":"Apis.Countries is a GenServer that manages a cache of countries,\nobtained from a REST API at https://restcountries.com/v3.1/all,\nand provides a set of functions to query this cache.","ref":"BCApis.Countries.html"},{"type":"function","title":"BCApis.Countries.all_countries/0","doc":"","ref":"BCApis.Countries.html#all_countries/0"},{"type":"function","title":"BCApis.Countries.all_regions/0","doc":"","ref":"BCApis.Countries.html#all_regions/0"},{"type":"function","title":"BCApis.Countries.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"BCApis.Countries.html#child_spec/1"},{"type":"function","title":"BCApis.Countries.clear/0","doc":"","ref":"BCApis.Countries.html#clear/0"},{"type":"function","title":"BCApis.Countries.countries_of_regions/3","doc":"","ref":"BCApis.Countries.html#countries_of_regions/3"},{"type":"function","title":"BCApis.Countries.farmable_countries/2","doc":"","ref":"BCApis.Countries.html#farmable_countries/2"},{"type":"function","title":"BCApis.Countries.get_country_by_country_code/1","doc":"","ref":"BCApis.Countries.html#get_country_by_country_code/1"},{"type":"function","title":"BCApis.Countries.independent_countries/1","doc":"","ref":"BCApis.Countries.html#independent_countries/1"},{"type":"function","title":"BCApis.Countries.random_country/0","doc":"","ref":"BCApis.Countries.html#random_country/0"},{"type":"function","title":"BCApis.Countries.refresh/1","doc":"","ref":"BCApis.Countries.html#refresh/1"},{"type":"function","title":"BCApis.Countries.start/1","doc":"","ref":"BCApis.Countries.html#start/1"},{"type":"function","title":"BCApis.Countries.start_link/1","doc":"","ref":"BCApis.Countries.html#start_link/1"},{"type":"function","title":"BCApis.Countries.stop/0","doc":"","ref":"BCApis.Countries.html#stop/0"},{"type":"module","title":"BCApis.Geocoding","doc":"Geocoding service to convert city names to coordinates using Open-Meteo Geocoding API.\n\nOpen-Meteo provides free geocoding without requiring an API key.","ref":"BCApis.Geocoding.html"},{"type":"function","title":"BCApis.Geocoding.coordinates_to_location_string/2","doc":"Converts coordinates back to a location string for storage.","ref":"BCApis.Geocoding.html#coordinates_to_location_string/2"},{"type":"function","title":"Parameters - BCApis.Geocoding.coordinates_to_location_string/2","doc":"- `lat`: Latitude (float)\n- `lon`: Longitude (float)","ref":"BCApis.Geocoding.html#coordinates_to_location_string/2-parameters"},{"type":"function","title":"Returns - BCApis.Geocoding.coordinates_to_location_string/2","doc":"- Location string in \"lat,lon\" format","ref":"BCApis.Geocoding.html#coordinates_to_location_string/2-returns"},{"type":"function","title":"BCApis.Geocoding.geocode_city/3","doc":"Converts a city name and country code to coordinates.","ref":"BCApis.Geocoding.html#geocode_city/3"},{"type":"function","title":"Parameters - BCApis.Geocoding.geocode_city/3","doc":"- `city`: City name (string)\n- `country_code`: ISO 3166 country code (string)\n- `api_key`: Not used (Open-Meteo is free and doesn't require API key)","ref":"BCApis.Geocoding.html#geocode_city/3-parameters"},{"type":"function","title":"Returns - BCApis.Geocoding.geocode_city/3","doc":"- `{:ok, {lat, lon}}` on success\n- `{:error, reason}` on failure","ref":"BCApis.Geocoding.html#geocode_city/3-returns"},{"type":"function","title":"BCApis.Geocoding.get_major_cities/1","doc":"Get a list of major cities for a given country code.\nThis is a simple static list - in a real application, you might want to use a more comprehensive database.","ref":"BCApis.Geocoding.html#get_major_cities/1"},{"type":"module","title":"BCApis.IpInfoCache","doc":"The Cache module is used to store and retrieve data from the IpInfo API.","ref":"BCApis.IpInfoCache.html"},{"type":"function","title":"BCApis.IpInfoCache.refresh/0","doc":"","ref":"BCApis.IpInfoCache.html#refresh/0"},{"type":"module","title":"BCApis.Weather","doc":"Weather service for integrating with Open-Meteo API.\n\nProvides functions to fetch current weather data and correlate it with\ngreenhouse environmental conditions.\n\nOpen-Meteo is a free, open-source weather API that doesn't require an API key.","ref":"BCApis.Weather.html"},{"type":"function","title":"BCApis.Weather.get_current_weather/3","doc":"Fetches current weather data for a given location.","ref":"BCApis.Weather.html#get_current_weather/3"},{"type":"function","title":"Parameters - BCApis.Weather.get_current_weather/3","doc":"- `lat`: Latitude (float)\n- `lon`: Longitude (float)\n- `api_key`: Not used (Open-Meteo is free and doesn't require API key)","ref":"BCApis.Weather.html#get_current_weather/3-parameters"},{"type":"function","title":"Returns - BCApis.Weather.get_current_weather/3","doc":"- `{:ok, weather_data}` on success\n- `{:error, reason}` on failure","ref":"BCApis.Weather.html#get_current_weather/3-returns"},{"type":"function","title":"BCApis.Weather.get_uv_index/3","doc":"Fetches UV index data for a given location.","ref":"BCApis.Weather.html#get_uv_index/3"},{"type":"function","title":"Parameters - BCApis.Weather.get_uv_index/3","doc":"- `lat`: Latitude (float)\n- `lon`: Longitude (float)\n- `api_key`: Not used (Open-Meteo is free and doesn't require API key)","ref":"BCApis.Weather.html#get_uv_index/3-parameters"},{"type":"function","title":"Returns - BCApis.Weather.get_uv_index/3","doc":"- `{:ok, uv_data}` on success\n- `{:error, reason}` on failure","ref":"BCApis.Weather.html#get_uv_index/3-returns"},{"type":"function","title":"BCApis.Weather.weather_to_greenhouse_conditions/1","doc":"Converts outdoor weather conditions to estimated greenhouse conditions.\n\nGreenhouses typically have:\n- Higher temperature (due to greenhouse effect)\n- Higher humidity (controlled environment)\n- Reduced light (filtered through glass/plastic)","ref":"BCApis.Weather.html#weather_to_greenhouse_conditions/1"},{"type":"extras","title":"Getting Started","doc":"# BEAM Campus APIs\n\nBEAM Campus APIs (BCApis) provides a collection of freely available APIs for Elixir projects. It includes services for geocoding, weather information, country data, and IP information.","ref":"getting-started.html"},{"type":"extras","title":"Installing BEAM Campus APIs - Getting Started","doc":"","ref":"getting-started.html#installing-beam-campus-apis"},{"type":"extras","title":"In mix.exs - Getting Started","doc":"Add BCApis to your list of dependencies:\n\n```elixir\ndef deps do\n  [\n    {:bc_apis, \"~> 0.1.0\"},\n    \n    # Optional Dependencies\n    {:jason, \"~> 1.4\"},           # If you need JSON handling\n    {:phoenix_pubsub, \"~> 2.1\"}  # If you need PubSub functionality\n  ]\nend\n```","ref":"getting-started.html#in-mix-exs"},{"type":"extras","title":"Required Runtime Dependencies - Getting Started","doc":"BCApis has these core dependencies:\n- `uuidv7` and `elixir_uuid` for ID generation\n- `telemetry` for metrics and instrumentation\n- `bc_utils` for BEAM Campus utilities","ref":"getting-started.html#required-runtime-dependencies"},{"type":"extras","title":"Optional Dependencies - Getting Started","doc":"Some features require optional dependencies:\n- `jason` for JSON handling\n- `phoenix_pubsub` for PubSub functionality\n- `req` and `hackney` for HTTP capabilities\n- `typed_struct` for type-safe structs\n- `cachex` for caching","ref":"getting-started.html#optional-dependencies"},{"type":"extras","title":"Available APIs - Getting Started","doc":"| API | Free? | Purpose | Guide |\n|-----|--------|---------|--------|\n| Geocoding | ✅ | Convert city names to coordinates | [Guide](./geocoding.md) |\n| Weather | ✅ | Get weather and UV index data | [Guide](./weather.md) |\n| Countries | ✅ | Access country information | [Guide](./countries.md) |\n| IP Info | ✅ | Get location from IP addresses | [Guide](./ip_info.md) |","ref":"getting-started.html#available-apis"},{"type":"extras","title":"Quick Start Example - Getting Started","doc":"```elixir\n# Start the Countries service (required for some features)\nBCApis.Countries.start(true)\n\n# Get coordinates for a city\n{:ok, {lat, lon}} = BCApis.Geocoding.geocode_city(\"London\", \"GB\", nil)\n\n# Get current weather\n{:ok, weather} = BCApis.Weather.get_current_weather(lat, lon, nil)\n\n# Get country information\n{:ok, country} = BCApis.Countries.get_country_by_country_code(\"GB\")\n\n# Get IP information\n{:ok, ip_info} = BCApis.IpInfoCache.refresh()\n```","ref":"getting-started.html#quick-start-example"},{"type":"extras","title":"Configuration - Getting Started","doc":"Most services are provided by free APIs that don't require API keys:","ref":"getting-started.html#configuration"},{"type":"extras","title":"Geocoding and Weather - Getting Started","doc":"Provided by Open-Meteo:\n- No API key required\n- Free tier with generous limits\n- Uses `https://geocoding-api.open-meteo.com/v1`\n- Uses `https://api.open-meteo.com/v1`","ref":"getting-started.html#geocoding-and-weather"},{"type":"extras","title":"Countries Data - Getting Started","doc":"Provided by restcountries.com:\n- No API key required\n- Can work offline with local data\n- Uses `https://restcountries.com/v3.1`","ref":"getting-started.html#countries-data"},{"type":"extras","title":"IP Information - Getting Started","doc":"Provided by ip-api.com:\n- No API key required\n- Free tier with rate limits\n- Uses `http://ip-api.com/json`","ref":"getting-started.html#ip-information"},{"type":"extras","title":"Development Tools - Getting Started","doc":"BCApis includes several development tools:","ref":"getting-started.html#development-tools"},{"type":"extras","title":"Code Quality - Getting Started","doc":"```bash\n# Type checking\nmix dialyzer\n\n# Code analysis\nmix credo\n\n# Documentation\nmix docs\n```","ref":"getting-started.html#code-quality"},{"type":"extras","title":"Testing - Getting Started","doc":"```bash\n# Run tests\nmix test\n\n# Watch for changes\nmix test.watch\n\n# Check coverage\nmix coveralls\n```","ref":"getting-started.html#testing"},{"type":"extras","title":"Common Use Cases - Getting Started","doc":"","ref":"getting-started.html#common-use-cases"},{"type":"extras","title":"1. Getting Weather for a City - Getting Started","doc":"```elixir\nwith {:ok, {lat, lon}} <- BCApis.Geocoding.geocode_city(\"Paris\", \"FR\", nil),\n     {:ok, weather} <- BCApis.Weather.get_current_weather(lat, lon, nil) do\n  # Process weather data\n  weather.temperature\n  weather.humidity\n  weather.weather_condition\nend\n```","ref":"getting-started.html#1-getting-weather-for-a-city"},{"type":"extras","title":"2. Finding Countries by Region - Getting Started","doc":"```elixir\n# Start the service\nBCApis.Countries.start(true)\n\n# Get European countries with minimum area and population\ncountries = BCApis.Countries.countries_of_regions(\n  [\"Europe\"],  # regions\n  100_000,    # min area km²\n  1_000_000   # min population\n)\n```","ref":"getting-started.html#2-finding-countries-by-region"},{"type":"extras","title":"3. Getting Location from IP - Getting Started","doc":"```elixir\n{:ok, info} = BCApis.IpInfoCache.refresh()\n\nlocation = {\n  city: info[\"city\"],\n  country: info[\"country\"],\n  timezone: info[\"timezone\"]\n}\n```","ref":"getting-started.html#3-getting-location-from-ip"},{"type":"extras","title":"Error Handling - Getting Started","doc":"All APIs use consistent error tuples:\n\n```elixir\n# Success\n{:ok, result} = BCApis.Geocoding.geocode_city(\"London\", \"GB\", nil)\n\n# Various errors\n{:error, :not_found}           # Resource not found\n{:error, :invalid_parameters}  # Bad input\n{:error, {:http_error, reason}} # Network issues\n{:error, reason}              # Other errors\n```","ref":"getting-started.html#error-handling"},{"type":"extras","title":"Learn More - Getting Started","doc":"- [Geocoding Guide](./geocoding.md)\n- [Weather Guide](./weather.md)\n- [Countries Guide](./countries.md)\n- [IP Info Guide](./ip_info.md)","ref":"getting-started.html#learn-more"},{"type":"extras","title":"Contributing - Getting Started","doc":"Issues and pull requests are welcome on GitHub at https://github.com/beam-campus/bc_apis.","ref":"getting-started.html#contributing"},{"type":"extras","title":"License - Getting Started","doc":"The package is available as open source under the terms of the MIT License.","ref":"getting-started.html#license"},{"type":"extras","title":"Read Me","doc":"# Package\n\n**TODO: Add description**","ref":"readme.html"},{"type":"extras","title":"Installation - Read Me","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `package` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:package, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}